type App = {
	client_id: string;
	client_secret: string;
	id: string;
	name: string;
};

const createApp = async (instance: string): Promise<App> => {
	const url = `${instance}/api/v1/apps`;
	const form = new window.FormData();

	form.append('client_name', `scuffs`);
	form.append('redirect_uris', `${window.location.origin}/oauth-callback`);
	form.append('scopes', 'read write follow push');

	const response = await fetch(url, {
		method: 'POST',
		body: form
	});
	return await response.json();
};

const getTokenFromCredentials = async (
	instance: string,
	app: App,
	username: string,
	password: string
) => {
	const url = `${instance}/oauth/token`;
	const form = new window.FormData();

	form.append('client_id', app.client_id);
	form.append('client_secret', app.client_secret);
	form.append('grant_type', 'password');
	form.append('username', username);
	form.append('password', password);

	const response = await fetch(url, {
		method: 'POST',
		body: form
	});
	return await response.json();
};

const oauth = {
	createApp,
	getTokenFromCredentials
};

export default oauth;
